{-# LANGUAGE OverloadedStrings #-}

module Main where

import           Control.Concurrent.Async (wait)
import           Pipes.IRC.Server         (startIrcServer)
import           Pipes.IRC.Server.Types   (HostPreference (Host),
                                           IrcConfig (..))

main :: IO ()
main =
  let
    ircConf =
      IrcConfig { ircPort = "6665"
                , ircHost = Host "127.0.0.1"
                , ircMotd = ["Welcome to the IRC Server!"]
                , ircPass = Nothing
                }
  in do
    listener <- startIrcServer ircConf
    wait listener
